Subject: bug#66187: read-file-name unexpected behavior when MUSTMATCH is a function

From: Eli Zaretskii <[email-masked]>
Date: Fri, 06 Oct 2023 07:45:39 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: Joseph Turner <[email-masked]>,  [email-masked],
>   [email-masked],  [email-masked]
> Date: Thu, 05 Oct 2023 15:34:32 -0400
> 
> >> For example, given:
> >> 
> >> (completing-read "Prompt: " '("a" "b") nil
> >>                  (lambda (input)
> >>                    (string= "a" input)))
> >> 
> >> I expected that the prompt would refuse to complete "b". I was wrong.
> >> 
> >> Since completing-read is such a fundamental part of Emacs, I doubt it
> >> will be possible to change this behavior.  What do you think about the
> >> attached patch to clarify the completing-read docstring?
> 
> The use of a function as `require-match` is brand new in Emacs-29, so
> I think it's not too late to fix it.  I think rather than fixing the doc
> we should fix the behavior, e.g. with the patch below.

What change in behavior (wrt Emacs 29.1) does this patch cause?